/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CENTCUST                                                 */
/* Tabela : CENTCUST                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CENTCUST'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CENTCUST
GO

CREATE TRIGGER DTULTATU_CENTCUST
ON CENTCUST
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CENTCUST', null, 'CDCENTCUST='+ CDCENTCUST+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CENTCUST
      SET DTULTATUCCUS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CENTCUST.CDCENTCUST,0) = ISNULL(INSERTED.CDCENTCUST,0)) AND
            (ISNULL(CENTCUST.NMCENTCUST,0) = ISNULL(INSERTED.NMCENTCUST,0));
   END;
END;
GO

UPDATE CENTCUST SET DTULTATUCCUS = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUCCUS IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUCENTCUST' and
            type = 'D')
   ALTER TABLE CENTCUST DROP CONSTRAINT DEFAULT_DTULTATUCENTCUST
GO

ALTER TABLE CENTCUST ADD CONSTRAINT DEFAULT_DTULTATUCENTCUST
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUCCUS
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CENTCUST','5.09.999';
GO
