/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CIAFILI                                                  */
/* Tabela : CIAFILI                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CIAFILI' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CIAFILI
GO

CREATE TRIGGER DTULTATU_CIAFILI
ON CIAFILI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CIAFILI', CDFILIAL, 'CDFILIAL='+ CDFILIAL+ ';'+
                                            'CDCIA='   + CDCIA   + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CIAFILI
      SET DTULTATUCFIL = GETDATE()
      FROM INSERTED;
   END;
END;
GO

